rebase: add --show-current-patch
[alt-git.git] / git-rebase.sh
blob41c915d18c2c4e160b4208dfc859f28ee54eb090
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_STUCKLONG=t
9 OPTIONS_SPEC="\
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
11 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
12 git rebase --continue | --abort | --skip | --edit-todo
14 Available options are
15 v,verbose! display a diffstat of what changed upstream
16 q,quiet! be quiet. implies --no-stat
17 autostash automatically stash/stash pop before and after
18 fork-point use 'merge-base --fork-point' to refine upstream
19 onto=! rebase onto given branch instead of upstream
20 p,preserve-merges! try to recreate merges instead of ignoring them
21 s,strategy=! use the given merge strategy
22 no-ff! cherry-pick all commits, even if unchanged
23 m,merge! use merging strategies to rebase
24 i,interactive! let the user edit the list of commits to rebase
25 x,exec=! add exec lines after each commit of the editable list
26 k,keep-empty preserve empty commits during rebase
27 f,force-rebase! force rebase even if branch is up to date
28 X,strategy-option=! pass the argument through to the merge strategy
29 stat! display a diffstat of what changed upstream
30 n,no-stat! do not show diffstat of what changed upstream
31 verify allow pre-rebase hook to run
32 rerere-autoupdate allow rerere to update index with resolved conflicts
33 root! rebase all reachable commits up to the root(s)
34 autosquash move commits that begin with squash!/fixup! under -i
35 committer-date-is-author-date! passed to 'git am'
36 ignore-date! passed to 'git am'
37 signoff passed to 'git am'
38 whitespace=! passed to 'git apply'
39 ignore-whitespace! passed to 'git apply'
40 C=! passed to 'git apply'
41 S,gpg-sign? GPG-sign commits
42 Actions:
43 continue! continue
44 abort! abort and check out the original branch
45 skip! skip current patch and continue
46 edit-todo! edit the todo list during an interactive rebase
47 quit! abort but keep HEAD where it is
48 show-current-patch! show the patch file being applied or merged
50 . git-sh-setup
51 set_reflog_action rebase
52 require_work_tree_exists
53 cd_to_toplevel
55 LF='
57 ok_to_skip_pre_rebase=
58 resolvemsg="
59 $(gettext 'Resolve all conflicts manually, mark them as resolved with
60 "git add/rm <conflicted_files>", then run "git rebase --continue".
61 You can instead skip this commit: run "git rebase --skip".
62 To abort and get back to the state before "git rebase", run "git rebase --abort".')
64 unset onto
65 unset restrict_revision
66 cmd=
67 strategy=
68 strategy_opts=
69 do_merge=
70 merge_dir="$GIT_DIR"/rebase-merge
71 apply_dir="$GIT_DIR"/rebase-apply
72 verbose=
73 diffstat=
74 test "$(git config --bool rebase.stat)" = true && diffstat=t
75 autostash="$(git config --bool rebase.autostash || echo false)"
76 fork_point=auto
77 git_am_opt=
78 git_format_patch_opt=
79 rebase_root=
80 force_rebase=
81 allow_rerere_autoupdate=
82 # Non-empty if a rebase was in progress when 'git rebase' was invoked
83 in_progress=
84 # One of {am, merge, interactive}
85 type=
86 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
87 state_dir=
88 # One of {'', continue, skip, abort}, as parsed from command line
89 action=
90 preserve_merges=
91 autosquash=
92 keep_empty=
93 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
94 case "$(git config --bool commit.gpgsign)" in
95 true) gpg_sign_opt=-S ;;
96 *) gpg_sign_opt= ;;
97 esac
99 read_basic_state () {
100 test -f "$state_dir/head-name" &&
101 test -f "$state_dir/onto" &&
102 head_name=$(cat "$state_dir"/head-name) &&
103 onto=$(cat "$state_dir"/onto) &&
104 # We always write to orig-head, but interactive rebase used to write to
105 # head. Fall back to reading from head to cover for the case that the
106 # user upgraded git with an ongoing interactive rebase.
107 if test -f "$state_dir"/orig-head
108 then
109 orig_head=$(cat "$state_dir"/orig-head)
110 else
111 orig_head=$(cat "$state_dir"/head)
112 fi &&
113 GIT_QUIET=$(cat "$state_dir"/quiet) &&
114 test -f "$state_dir"/verbose && verbose=t
115 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
116 test -f "$state_dir"/strategy_opts &&
117 strategy_opts="$(cat "$state_dir"/strategy_opts)"
118 test -f "$state_dir"/allow_rerere_autoupdate &&
119 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
120 test -f "$state_dir"/gpg_sign_opt &&
121 gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
124 write_basic_state () {
125 echo "$head_name" > "$state_dir"/head-name &&
126 echo "$onto" > "$state_dir"/onto &&
127 echo "$orig_head" > "$state_dir"/orig-head &&
128 echo "$GIT_QUIET" > "$state_dir"/quiet &&
129 test t = "$verbose" && : > "$state_dir"/verbose
130 test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
131 test -n "$strategy_opts" && echo "$strategy_opts" > \
132 "$state_dir"/strategy_opts
133 test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
134 "$state_dir"/allow_rerere_autoupdate
135 test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
138 output () {
139 case "$verbose" in
141 output=$("$@" 2>&1 )
142 status=$?
143 test $status != 0 && printf "%s\n" "$output"
144 return $status
147 "$@"
149 esac
152 move_to_original_branch () {
153 case "$head_name" in
154 refs/*)
155 message="rebase finished: $head_name onto $onto"
156 git update-ref -m "$message" \
157 $head_name $(git rev-parse HEAD) $orig_head &&
158 git symbolic-ref \
159 -m "rebase finished: returning to $head_name" \
160 HEAD $head_name ||
161 die "$(eval_gettext "Could not move back to \$head_name")"
163 esac
166 apply_autostash () {
167 if test -f "$state_dir/autostash"
168 then
169 stash_sha1=$(cat "$state_dir/autostash")
170 if git stash apply $stash_sha1 >/dev/null 2>&1
171 then
172 echo "$(gettext 'Applied autostash.')" >&2
173 else
174 git stash store -m "autostash" -q $stash_sha1 ||
175 die "$(eval_gettext "Cannot store \$stash_sha1")"
176 gettext 'Applying autostash resulted in conflicts.
177 Your changes are safe in the stash.
178 You can run "git stash pop" or "git stash drop" at any time.
179 ' >&2
184 finish_rebase () {
185 apply_autostash &&
186 { git gc --auto || true; } &&
187 rm -rf "$state_dir"
190 run_specific_rebase () {
191 if [ "$interactive_rebase" = implied ]; then
192 GIT_EDITOR=:
193 export GIT_EDITOR
194 autosquash=
196 . git-rebase--$type
197 ret=$?
198 if test $ret -eq 0
199 then
200 finish_rebase
201 elif test $ret -eq 2 # special exit status for rebase -i
202 then
203 apply_autostash &&
204 rm -rf "$state_dir" &&
205 die "Nothing to do"
207 exit $ret
210 run_pre_rebase_hook () {
211 if test -z "$ok_to_skip_pre_rebase" &&
212 test -x "$(git rev-parse --git-path hooks/pre-rebase)"
213 then
214 "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
215 die "$(gettext "The pre-rebase hook refused to rebase.")"
219 test -f "$apply_dir"/applying &&
220 die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
222 if test -d "$apply_dir"
223 then
224 type=am
225 state_dir="$apply_dir"
226 elif test -d "$merge_dir"
227 then
228 if test -f "$merge_dir"/interactive
229 then
230 type=interactive
231 interactive_rebase=explicit
232 else
233 type=merge
235 state_dir="$merge_dir"
237 test -n "$type" && in_progress=t
239 total_argc=$#
240 while test $# != 0
242 case "$1" in
243 --no-verify)
244 ok_to_skip_pre_rebase=yes
246 --verify)
247 ok_to_skip_pre_rebase=
249 --continue|--skip|--abort|--quit|--edit-todo|--show-current-patch)
250 test $total_argc -eq 2 || usage
251 action=${1##--}
253 --onto=*)
254 onto="${1#--onto=}"
256 --exec=*)
257 cmd="${cmd}exec ${1#--exec=}${LF}"
258 test -z "$interactive_rebase" && interactive_rebase=implied
260 --interactive)
261 interactive_rebase=explicit
263 --keep-empty)
264 keep_empty=yes
266 --preserve-merges)
267 preserve_merges=t
268 test -z "$interactive_rebase" && interactive_rebase=implied
270 --autosquash)
271 autosquash=t
273 --no-autosquash)
274 autosquash=
276 --fork-point)
277 fork_point=t
279 --no-fork-point)
280 fork_point=
282 --merge)
283 do_merge=t
285 --strategy-option=*)
286 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
287 do_merge=t
288 test -z "$strategy" && strategy=recursive
290 --strategy=*)
291 strategy="${1#--strategy=}"
292 do_merge=t
294 --no-stat)
295 diffstat=
297 --stat)
298 diffstat=t
300 --autostash)
301 autostash=true
303 --no-autostash)
304 autostash=false
306 --verbose)
307 verbose=t
308 diffstat=t
309 GIT_QUIET=
311 --quiet)
312 GIT_QUIET=t
313 git_am_opt="$git_am_opt -q"
314 verbose=
315 diffstat=
317 --whitespace=*)
318 git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
319 case "${1#--whitespace=}" in
320 fix|strip)
321 force_rebase=t
323 esac
325 --ignore-whitespace)
326 git_am_opt="$git_am_opt $1"
328 --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
329 git_am_opt="$git_am_opt $1"
330 force_rebase=t
332 -C*)
333 git_am_opt="$git_am_opt $1"
335 --root)
336 rebase_root=t
338 --force-rebase|--no-ff)
339 force_rebase=t
341 --rerere-autoupdate|--no-rerere-autoupdate)
342 allow_rerere_autoupdate="$1"
344 --gpg-sign)
345 gpg_sign_opt=-S
347 --gpg-sign=*)
348 gpg_sign_opt="-S${1#--gpg-sign=}"
351 shift
352 break
355 usage
357 esac
358 shift
359 done
360 test $# -gt 2 && usage
362 if test -n "$action"
363 then
364 test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
365 # Only interactive rebase uses detailed reflog messages
366 if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
367 then
368 GIT_REFLOG_ACTION="rebase -i ($action)"
369 export GIT_REFLOG_ACTION
373 if test "$action" = "edit-todo" && test "$type" != "interactive"
374 then
375 die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
378 case "$action" in
379 continue)
380 # Sanity check
381 git rev-parse --verify HEAD >/dev/null ||
382 die "$(gettext "Cannot read HEAD")"
383 git update-index --ignore-submodules --refresh &&
384 git diff-files --quiet --ignore-submodules || {
385 echo "$(gettext "You must edit all merge conflicts and then
386 mark them as resolved using git add")"
387 exit 1
389 read_basic_state
390 run_specific_rebase
392 skip)
393 output git reset --hard HEAD || exit $?
394 read_basic_state
395 run_specific_rebase
397 abort)
398 git rerere clear
399 read_basic_state
400 case "$head_name" in
401 refs/*)
402 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
403 die "$(eval_gettext "Could not move back to \$head_name")"
405 esac
406 output git reset --hard $orig_head
407 finish_rebase
408 exit
410 quit)
411 exec rm -rf "$state_dir"
413 edit-todo)
414 run_specific_rebase
416 show-current-patch)
417 run_specific_rebase
418 die "BUG: run_specific_rebase is not supposed to return here"
420 esac
422 # Make sure no rebase is in progress
423 if test -n "$in_progress"
424 then
425 state_dir_base=${state_dir##*/}
426 cmd_live_rebase="git rebase (--continue | --abort | --skip)"
427 cmd_clear_stale_rebase="rm -fr \"$state_dir\""
428 die "
429 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
430 I wonder if you are in the middle of another rebase. If that is the
431 case, please try
432 $cmd_live_rebase
433 If that is not the case, please
434 $cmd_clear_stale_rebase
435 and run me again. I am stopping in case you still have something
436 valuable there.')"
439 if test -n "$rebase_root" && test -z "$onto"
440 then
441 test -z "$interactive_rebase" && interactive_rebase=implied
444 if test -n "$interactive_rebase"
445 then
446 type=interactive
447 state_dir="$merge_dir"
448 elif test -n "$do_merge"
449 then
450 type=merge
451 state_dir="$merge_dir"
452 else
453 type=am
454 state_dir="$apply_dir"
457 if test -t 2 && test -z "$GIT_QUIET"
458 then
459 git_format_patch_opt="$git_format_patch_opt --progress"
462 if test -z "$rebase_root"
463 then
464 case "$#" in
466 if ! upstream_name=$(git rev-parse --symbolic-full-name \
467 --verify -q @{upstream} 2>/dev/null)
468 then
469 . git-parse-remote
470 error_on_missing_default_upstream "rebase" "rebase" \
471 "against" "git rebase $(gettext '<branch>')"
474 test "$fork_point" = auto && fork_point=t
476 *) upstream_name="$1"
477 if test "$upstream_name" = "-"
478 then
479 upstream_name="@{-1}"
481 shift
483 esac
484 upstream=$(peel_committish "${upstream_name}") ||
485 die "$(eval_gettext "invalid upstream '\$upstream_name'")"
486 upstream_arg="$upstream_name"
487 else
488 if test -z "$onto"
489 then
490 empty_tree=$(git hash-object -t tree /dev/null)
491 onto=$(git commit-tree $empty_tree </dev/null)
492 squash_onto="$onto"
494 unset upstream_name
495 unset upstream
496 test $# -gt 1 && usage
497 upstream_arg=--root
500 # Make sure the branch to rebase onto is valid.
501 onto_name=${onto-"$upstream_name"}
502 case "$onto_name" in
503 *...*)
504 if left=${onto_name%...*} right=${onto_name#*...} &&
505 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
506 then
507 case "$onto" in
508 ?*"$LF"?*)
509 die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
512 die "$(eval_gettext "\$onto_name: there is no merge base")"
514 esac
515 else
516 die "$(eval_gettext "\$onto_name: there is no merge base")"
520 onto=$(peel_committish "$onto_name") ||
521 die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
523 esac
525 # If the branch to rebase is given, that is the branch we will rebase
526 # $branch_name -- branch/commit being rebased, or HEAD (already detached)
527 # $orig_head -- commit object name of tip of the branch before rebasing
528 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
529 switch_to=
530 case "$#" in
532 # Is it "rebase other $branchname" or "rebase other $commit"?
533 branch_name="$1"
534 switch_to="$1"
536 # Is it a local branch?
537 if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
538 orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
539 then
540 head_name="refs/heads/$branch_name"
541 # If not is it a valid ref (branch or commit)?
542 elif orig_head=$(git rev-parse -q --verify "$branch_name")
543 then
544 head_name="detached HEAD"
546 else
547 die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
551 # Do not need to switch branches, we are already on it.
552 if branch_name=$(git symbolic-ref -q HEAD)
553 then
554 head_name=$branch_name
555 branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
556 else
557 head_name="detached HEAD"
558 branch_name=HEAD
560 orig_head=$(git rev-parse --verify HEAD) || exit
563 die "BUG: unexpected number of arguments left to parse"
565 esac
567 if test "$fork_point" = t
568 then
569 new_upstream=$(git merge-base --fork-point "$upstream_name" \
570 "${switch_to:-HEAD}")
571 if test -n "$new_upstream"
572 then
573 restrict_revision=$new_upstream
577 if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
578 then
579 stash_sha1=$(git stash create "autostash") ||
580 die "$(gettext 'Cannot autostash')"
582 mkdir -p "$state_dir" &&
583 echo $stash_sha1 >"$state_dir/autostash" &&
584 stash_abbrev=$(git rev-parse --short $stash_sha1) &&
585 echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
586 git reset --hard
589 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
591 # Now we are rebasing commits $upstream..$orig_head (or with --root,
592 # everything leading up to $orig_head) on top of $onto
594 # Check if we are already based on $onto with linear history,
595 # but this should be done only when upstream and onto are the same
596 # and if this is not an interactive rebase.
597 mb=$(git merge-base "$onto" "$orig_head")
598 if test "$type" != interactive && test "$upstream" = "$onto" &&
599 test "$mb" = "$onto" && test -z "$restrict_revision" &&
600 # linear history?
601 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
602 then
603 if test -z "$force_rebase"
604 then
605 # Lazily switch to the target branch if needed...
606 test -z "$switch_to" ||
607 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
608 git checkout -q "$switch_to" --
609 if test "$branch_name" = "HEAD" &&
610 ! git symbolic-ref -q HEAD
611 then
612 say "$(eval_gettext "HEAD is up to date.")"
613 else
614 say "$(eval_gettext "Current branch \$branch_name is up to date.")"
616 finish_rebase
617 exit 0
618 else
619 if test "$branch_name" = "HEAD" &&
620 ! git symbolic-ref -q HEAD
621 then
622 say "$(eval_gettext "HEAD is up to date, rebase forced.")"
623 else
624 say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
629 # If a hook exists, give it a chance to interrupt
630 run_pre_rebase_hook "$upstream_arg" "$@"
632 if test -n "$diffstat"
633 then
634 if test -n "$verbose"
635 then
636 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
638 # We want color (if set), but no pager
639 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
642 test "$type" = interactive && run_specific_rebase
644 # Detach HEAD and reset the tree
645 say "$(gettext "First, rewinding head to replay your work on top of it...")"
647 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
648 git checkout -q "$onto^0" || die "could not detach HEAD"
649 git update-ref ORIG_HEAD $orig_head
651 # If the $onto is a proper descendant of the tip of the branch, then
652 # we just fast-forwarded.
653 if test "$mb" = "$orig_head"
654 then
655 say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
656 move_to_original_branch
657 finish_rebase
658 exit 0
661 if test -n "$rebase_root"
662 then
663 revisions="$onto..$orig_head"
664 else
665 revisions="${restrict_revision-$upstream}..$orig_head"
668 run_specific_rebase